%define section free

Name:           checkstyle
Version:        3.4
Release:        1jpp
Epoch:          0
Summary:        Java source code checker
License:        LGPL
Group:          Development/Build Tools
Vendor:         JPackage Project
Distribution:   JPackage
Source0:        http://download.sf.net/checkstyle/checkstyle-src-3.4.tar.gz
Source1:        %{name}-script
Source2:        %{name}.catalog
Patch0:		%{name}-build.patch
Patch1:         %{name}-javadoc-crosslink.patch
URL:            http://checkstyle.sourceforge.net/
Requires:       ant, antlr >= 0:2.7.1, regexp >= 0:1.2, jakarta-commons-logging
Requires:       jakarta-commons-cli, jakarta-commons-beanutils
Requires:       jakarta-commons-collections, jpackage-utils >= 0:1.5
Requires:       jaxp_parser_impl
BuildRequires:  ant >= 0:1.5, ant-optional, junit, antlr >= 0:2.7.1
BuildRequires:  regexp >= 0:1.2, jakarta-commons-beanutils
BuildRequires:  jakarta-commons-cli, xalan-j2, junit, jpackage-utils >= 0:1.5
# xerces-j2 because tests fail with gnujaxp...
BuildRequires:  jakarta-commons-logging, jakarta-commons-collections, xerces-j2
BuildRequires:  antlr-javadoc, xml-commons-apis-javadoc, regexp-javadoc
BuildRequires:  jakarta-commons-beanutils-javadoc, ant-javadoc, /usr/bin/perl
BuildArch:      noarch
BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-buildroot

%description
A tool for checking Java source code for adherence to a set of rules.

%package        demo
Group:          Development/Build Tools
Summary:        Demos for %{name}
Requires:       %{name} = %{epoch}:%{version}-%{release}

%description    demo
Demonstrations and samples for %{name}.

%package        javadoc
Group:          Development/Documentation
Summary:        Javadoc for %{name}

%description    javadoc
Javadoc for %{name}.

%package        manual
Group:          Development/Build Tools
Summary:        Manual for %{name}

%description    manual
Manual for %{name}.

%package        optional
Group:          Development/Build Tools
Summary:        Optional functionality for %{name}
Requires:       %{name} = %{version}

%description    optional
Optional functionality for %{name}.


%prep
%setup -q -n %{name}-src-%{version}
%patch0 -p0
%patch1 -p0
perl -pi -e 's|\./{\@docRoot}/\.\./index\.html|%{_docdir}/%{name}-manual-%{version}/index.html|' build.xml
# remove all binary libs
find . -name "*.jar" -exec rm -f {} \;


%build
export CLASSPATH=$(build-classpath antlr regexp commons-beanutils \
commons-collections commons-cli commons-logging xalan-j2 junit)

ant \
  -Dbuild.sysclasspath=last \
  -Dant.javadoc=%{_javadocdir}/ant \
  -Dantlr.javadoc=%{_javadocdir}/antlr \
  -Djaxp.javadoc=%{_javadocdir}/xml-commons-apis \
  -Dbeanutils.javadoc=%{_javadocdir}/jakarta-commons-beanutils \
  -Dregexp.javadoc=%{_javadocdir}/regexp \
  run.tests build.bindist


%install
rm -rf $RPM_BUILD_ROOT

# jar
mkdir -p $RPM_BUILD_ROOT%{_javadir}
cp -p target/dist/%{name}-%{version}/%{name}-%{version}.jar \
  $RPM_BUILD_ROOT%{_javadir}
cp -p target/dist/%{name}-%{version}/%{name}-optional-%{version}.jar \
  $RPM_BUILD_ROOT%{_javadir}
(cd $RPM_BUILD_ROOT%{_javadir} && for jar in *-%{version}.jar; do ln -sf ${jar} `echo $jar| sed "s|-%{version}||g"`; done)

# script
mkdir -p $RPM_BUILD_ROOT%{_bindir}
cp -p %{SOURCE1} $RPM_BUILD_ROOT%{_bindir}/%{name}

# dtds
mkdir -p $RPM_BUILD_ROOT%{_datadir}/xml/%{name}
cp -p %{SOURCE2} $RPM_BUILD_ROOT%{_datadir}/xml/%{name}/catalog
mv target/dist/%{name}-%{version}/docs/xmllogger.dtd \
  $RPM_BUILD_ROOT%{_datadir}/xml/%{name}
cp -p src/checkstyle/com/puppycrawl/tools/checkstyle/*.dtd \
  $RPM_BUILD_ROOT%{_datadir}/xml/%{name}

# javadoc
mkdir -p $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}
cp -pr target/dist/%{name}-%{version}/docs/api/* \
  $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}
rm -rf target/dist/%{name}-%{version}/docs/api
ln -s %{_javadocdir}/%{name} target/dist/%{name}-%{version}/docs/api
ln -s %{name}-%{version} $RPM_BUILD_ROOT%{_javadocdir}/%{name} # ghost symlink

# demo
mkdir -p $RPM_BUILD_ROOT%{_datadir}/%name
cp -pr target/dist/%{name}-%{version}/contrib/* \
  $RPM_BUILD_ROOT%{_datadir}/%name/


%clean
rm -rf $RPM_BUILD_ROOT


%post
# Note that we're using a fully versioned catalog, so this is always ok.
if [ -x %{_bindir}/install-catalog -a -d %{_sysconfdir}/sgml ]; then
  %{_bindir}/install-catalog --add \
    %{_sysconfdir}/sgml/%{name}-%{version}-%{release}.cat \
    %{_datadir}/xml/%{name}/catalog > /dev/null || :
fi

%postun
# Note that we're using a fully versioned catalog, so this is always ok.
if [ -x %{_bindir}/install-catalog -a -d %{_sysconfdir}/sgml ]; then
  %{_bindir}/install-catalog --remove \
    %{_sysconfdir}/sgml/%{name}-%{version}-%{release}.cat \
    %{_datadir}/xml/%{name}/catalog > /dev/null || :
fi

%post javadoc
rm -f %{_javadocdir}/%{name}
ln -s %{name}-%{version} %{_javadocdir}/%{name}


%files
%defattr(0644,root,root,0755)
%doc LICENSE README TODO
%{_javadir}/%{name}.jar
%{_javadir}/%{name}-%{version}.jar
%{_datadir}/xml/%{name}
%attr(0755,root,root) %{_bindir}/*

%files demo
%defattr(0644,root,root,0755)
%{_datadir}/%{name}

%files javadoc
%defattr(0644,root,root,0755)
%doc %{_javadocdir}/%{name}-%{version}
%ghost %doc %{_javadocdir}/%{name}

%files manual
%defattr(0644,root,root,0755)
%doc target/dist/%{name}-%{version}/docs/*

%files optional
%defattr(0644,root,root,0755)
%{_javadir}/%{name}-optional.jar
%{_javadir}/%{name}-optional-%{version}.jar


%changelog
* Mon Apr 12 2004 Ville Skyttä <ville.skytta at iki.fi> - 0:3.4-1jpp
- Update to 3.4.
- Make -optional depend on the main package.
- Update DTD catalog, move DTDs to %%{_datadir}/xml/%%{name}.
- New style versionless javadoc dir symlinking.
- Add -optional jar to classpath in startup script if available.

* Tue Jan 20 2004 David Walluck <david@anti-microsoft.org> 0:3.3-1jpp
- 3.3
- rediff patches
- add `optional' subpackage

* Fri Jul 11 2003 Ville Skyttä <ville.skytta at iki.fi> - 0:3.1-2jpp
- Install DTDs into %%{_datadir}/sgml/%%{name}.
- Include catalog for DTDs, and install it if %%{_bindir}/install-catalog
  is available.
- Javadoc crosslinking.

* Wed Jun  4 2003 Ville Skyttä <ville.skytta at iki.fi> - 0:3.1-1jpp
- Update to 3.1.
- Non-versioned javadoc symlinking.

* Fri Apr  4 2003 Ville Skyttä <ville.skytta at iki.fi> - 0:3.0-2jpp
- Rebuild for JPackage 1.5.

* Sat Mar  1 2003 Ville Skyttä <ville.skytta at iki.fi> - 3.0-1jpp
- Update to 3.0.
- Run unit tests during build.
- Separate manual package.

* Sat Sep 14 2002 Ville Skyttä <ville.skytta at iki.fi> 2.4-1jpp
- 2.4.
- No RPM macros in source URL.
- Use (patched) ant build.bindist task to fix docs.

* Thu Jul 11 2002 Ville Skyttä <ville.skytta at iki.fi> 2.3-2jpp
- Unbreak build.
- Add shell script.

* Tue Jul  9 2002 Ville Skyttä <ville.skytta at iki.fi> 2.3-1jpp
- Updated to 2.3.
- Use sed instead of bash 2 extension when symlinking jars during build.
- BuildRequires ant-optional.

* Fri May 10 2002 Ville Skyttä <ville.skytta at iki.fi> 2.2-1jpp
- Updated to 2.2.
- Added versioned requirements.
- Fixed Distribution and Group tags.
- Added demo package.

* Sun Mar 03 2002 Guillaume Rousse <guillomovitch@users.sourceforge.net> 2.1-1jpp
- first jpp release
